searchNodes=[{"ref":"ExBench.Application.html","title":"ExBench.Application","type":"module","doc":""},{"ref":"ExBench.Application.html#default_filename/0","title":"ExBench.Application.default_filename/0","type":"function","doc":""},{"ref":"ExBench.Application.html#run/1","title":"ExBench.Application.run/1","type":"function","doc":""},{"ref":"ExBench.Application.html#start/2","title":"ExBench.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"ExBench.Application.html#stop/0","title":"ExBench.Application.stop/0","type":"function","doc":""},{"ref":"ExBench.Dev.Pipeline.html","title":"ExBench.Dev.Pipeline","type":"module","doc":""},{"ref":"ExBench.Dev.Pipeline.html#call/2","title":"ExBench.Dev.Pipeline.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"ExBench.Dev.Pipeline.html#init/1","title":"ExBench.Dev.Pipeline.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"ExBench.Dev.Plug.Root.html","title":"ExBench.Dev.Plug.Root","type":"module","doc":""},{"ref":"ExBench.Dev.Plug.Root.html#call/2","title":"ExBench.Dev.Plug.Root.call/2","type":"function","doc":""},{"ref":"ExBench.Dev.Plug.Root.html#init/1","title":"ExBench.Dev.Plug.Root.init/1","type":"function","doc":""},{"ref":"ExBench.DynamicSupervisor.html","title":"ExBench.DynamicSupervisor","type":"module","doc":""},{"ref":"ExBench.DynamicSupervisor.html#child_spec/1","title":"ExBench.DynamicSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExBench.DynamicSupervisor.html#init/1","title":"ExBench.DynamicSupervisor.init/1","type":"function","doc":"And this is the contortion you have to go through to get DynamicSupervisor to spawn children at init."},{"ref":"ExBench.DynamicSupervisor.html#start_child/1","title":"ExBench.DynamicSupervisor.start_child/1","type":"function","doc":""},{"ref":"ExBench.DynamicSupervisor.html#start_link/1","title":"ExBench.DynamicSupervisor.start_link/1","type":"function","doc":""},{"ref":"ExBench.FileProducer.html","title":"ExBench.FileProducer","type":"module","doc":""},{"ref":"ExBench.FileProducer.html#handle_demand/2","title":"ExBench.FileProducer.handle_demand/2","type":"function","doc":"Invoked on :producer stages. This callback is invoked on :producer stages with the demand from consumers/dispatcher. The producer that implements this callback must either store the demand, or return the amount of requested events. Must always be explicitly implemented by :producer stages. Examples def handle_demand(demand, state) do # We check if we&#39;re able to satisfy the demand and fetch # events if we aren&#39;t. events = if length(state.events) &gt;= demand do state.events else # fetch_events() end # We dispatch only the requested number of events. {to_dispatch, remaining} = Enum.split(events, demand) {:noreply, to_dispatch, %{state | events: remaining}} end Callback implementation for GenStage.handle_demand/2."},{"ref":"ExBench.FileProducer.html#init/1","title":"ExBench.FileProducer.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 (or start/3) will block until this callback returns. args is the argument term (second argument) passed to start_link/3 (or start/3). In case of successful start, this callback must return a tuple where the first element is the stage type, which is one of: :producer :consumer :producer_consumer (if the stage is acting as both) For example: def init(args) do {:producer, some_state} end The returned tuple may also contain 3 or 4 elements. The third element may be the :hibernate atom or a set of options defined below. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Options This callback may return options. Some options are specific to the chosen stage type while others are shared across all types. :producer options :demand - when :forward, the demand is always forwarded to the c:handle_demand/2 callback. When :accumulate, demand is accumulated until its mode is set to :forward via demand/2. This is useful as a synchronization mechanism, where the demand is accumulated until all consumers are subscribed. Defaults to :forward. :producer and :producer_consumer options :buffer_size - the size of the buffer to store events without demand. Can be :infinity to signal no limit on the buffer size. Check the &quot;Buffer events&quot; section of the module documentation. Defaults to 10_000 for :producer, :infinity for :producer_consumer. :buffer_keep - returns whether the :first or :last entries should be kept on the buffer in case the buffer size is exceeded. Defaults to :last. :dispatcher - the dispatcher responsible for handling demands. Defaults to GenStage.DemandDispatch. May be either an atom representing a dispatcher module or a two-element tuple with the dispatcher module and the dispatcher options. :consumer and :producer_consumer options :subscribe_to - a list of producers to subscribe to. Each element represents either the producer module or a tuple with the producer module and the subscription options (as defined in sync_subscribe/2). Callback implementation for GenStage.init/1."},{"ref":"ExBench.FileProducer.html#start_link/1","title":"ExBench.FileProducer.start_link/1","type":"function","doc":""},{"ref":"ExBench.FileProducer.LineParser.html","title":"ExBench.FileProducer.LineParser","type":"module","doc":""},{"ref":"ExBench.FileProducer.LineParser.html#parse/1","title":"ExBench.FileProducer.LineParser.parse/1","type":"function","doc":""},{"ref":"ExBench.Metrics.CommandInstrumenter.html","title":"ExBench.Metrics.CommandInstrumenter","type":"module","doc":""},{"ref":"ExBench.Metrics.CommandInstrumenter.html#counter_inc/1","title":"ExBench.Metrics.CommandInstrumenter.counter_inc/1","type":"function","doc":""},{"ref":"ExBench.Metrics.CommandInstrumenter.html#handle_event/4","title":"ExBench.Metrics.CommandInstrumenter.handle_event/4","type":"function","doc":""},{"ref":"ExBench.Metrics.CommandInstrumenter.html#setup/0","title":"ExBench.Metrics.CommandInstrumenter.setup/0","type":"function","doc":""},{"ref":"ExBench.Metrics.PlugExporter.html","title":"ExBench.Metrics.PlugExporter","type":"module","doc":""},{"ref":"ExBench.Metrics.PlugExporter.html#call/2","title":"ExBench.Metrics.PlugExporter.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"ExBench.Metrics.PlugExporter.html#init/1","title":"ExBench.Metrics.PlugExporter.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"ExBench.Metrics.PlugExporter.html#setup/0","title":"ExBench.Metrics.PlugExporter.setup/0","type":"function","doc":""},{"ref":"ExBench.Signaler.html","title":"ExBench.Signaler","type":"module","doc":""},{"ref":"ExBench.Signaler.html#child_spec/1","title":"ExBench.Signaler.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExBench.Signaler.html#start_link/1","title":"ExBench.Signaler.start_link/1","type":"function","doc":""},{"ref":"ExBench.Signaler.html#start_link/2","title":"ExBench.Signaler.start_link/2","type":"function","doc":""},{"ref":"ExBench.Worker.html","title":"ExBench.Worker","type":"module","doc":""},{"ref":"ExBench.Worker.html#child_spec/1","title":"ExBench.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExBench.Worker.html#init/1","title":"ExBench.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ExBench.Worker.html#start_link/1","title":"ExBench.Worker.start_link/1","type":"function","doc":""}]